#include "binds.hpp"
// definit ici et binde les fct lua necessaires
#include <luabind/luabind.hpp>

// Include needed policy
#include <luabind/copy_policy.hpp>
//#include <luabind/dependency_policy.hpp>
#include <luabind/out_value_policy.hpp>
#include <luabind/raw_policy.hpp>
#include <luabind/return_reference_to_policy.hpp>
#include <luabind/yield_policy.hpp>
#include <luabind/error.hpp>
#include <luabind/discard_result_policy.hpp>
#include "../states/IPlayStateLua.hpp"
#include "../IGameEngine.hpp"
#include "../game_engine.hpp"
#include <fusion/logging/Logger.hpp>
#include <fusion/scripting/Lua_utils.hpp>


using namespace irr;
using namespace fus;
using namespace core;
using namespace video;
using namespace scene;
using namespace gui;
using namespace luabind;



typedef void (*TCLoggingFunction)(const fus::ELogLevel&,const char*);



luabind::scope
createLoggerScope()
{

// Export our class with LuaBind/mLuaState

    return luabind::class_<fus::Logger>("Logger")
        .enum_("LogLevel")
        [
            value("Debug",fus::ELogLevel::Debug),
            value("Notice",fus::ELogLevel::Notice),
            value("Warning",fus::ELogLevel::Warning),
            value("Error",fus::ELogLevel::Error)

        ]
        .scope [
            //def("reportingLevel",&fus::Logger::reportingLevel),
            //def("Log", (void (fus::Logger:*)(const fus::ELogLevel&,const char*)) &fus::Logger::Log)

            def("Log", (TCLoggingFunction)&fus::Logger::Log)
        ]

//        ,luabind::class_<fus::Logger>("Logger")
        ;
}


//CSinglePlayerState
//CGraphicalLevel* levelMgr
luabind::scope
bindEngineToLua()
{

// Export our class with LuaBind/mLuaState

    return luabind::class_<vector3df>("vector3df")
    //luabind::def("print", &fus::luaPrint),
//(TCLoggingFunction) &fus::Logger::Log


    , luabind::class_<irr::scene::IAnimatedMesh>("IAnimatedMesh*")

    , luabind::class_<IPlayableState>("IPlayableState")
        .def("getUpperProgression", &IPlayableState::getProgression )
        .def("getMesh", &IPlayableState::getMesh )
        .def("getElapsedTime", &IPlayableState::getElapsedTime )


    , luabind::class_<CLuaPlayState, bases<IPlayableState> >("CLuaPlayState")
//            .def("loadLevel",&CSinglePlayerState::loadLevel)
  //          .def("isPlayerUpdatable",&CSinglePlayerState::isPlayerUpdatable)
            .def("update",&CLuaPlayState::onUpdate)
            .def("startDialog",&CLuaPlayState::startDialog)
        ,

//
    luabind::class_<IGameEngine>("IEngine")
        .def("getElapsedTime",&IGameEngine::getElapsedTime)
        ,

    luabind::class_<CGameEngine,IGameEngine>("Engine")

        //.def("startDialog",&CGameEngine::startDialog)
//        .def("setCamPos",&CGameEngine::setCamPos)
//        .def("setCamTarget",&CGameEngine::setCamTarget)

   ;

}
