#include "IWalkyrie.hpp"
#include "IWalkyrieMode.hpp"
#include "CGerwalkAnimator.hpp"
#include "CFighterAnimator.hpp"
#include "CTransformingMode.hpp"
#include <fusion/fusion.hpp>




IWalkyrieMode* IWalkyrie::FighterMode;
IWalkyrieMode* IWalkyrie::GerwalkMode;
IWalkyrieMode* IWalkyrie::TransformingMode;

//auto IWalkyrie::Modes;
//IWalkyrie::TModes IWalkyrie::Modes;


// initStaticMembers()

void
IWalkyrie::initialize()
{
//    Modes[]

    IPlayerAnimator* basicAnimator = new CFighterAnimator();
    FighterMode = new IWalkyrieMode("Fighter");
//    IWalkyrieMode* yf19fighter = FighterMode;
                    //s[NWalkyrieModes::yf19_Fighter];
//    IWalkyrieMode* yf19fighter

    FighterMode->setDefaultAnimator( basicAnimator );
    FighterMode->defineAnimation(3,5);
    FighterMode->setupSpeeds(
                    0.4 ,       //!< lateral speed
                     2   ,    //!< fwd
                     0.4 ,      //!< default fwd
                     0.9 ,  //!< backward
                     2 ,    //!< rolling
                     0.2)   //!< yaw
        ->setRange(3)
        ->setAngleBounds(0,40)
        ->setCameraRecul(0,20,-50);


    //yf19fighter.setCameraRecul(0,20,-50);

    GerwalkMode = new IWalkyrieMode("Gerwalk");
    GerwalkMode->setDefaultAnimator( basicAnimator );
    GerwalkMode->defineAnimation(12,5);
    GerwalkMode->setupSpeeds(0.5 , //!< lateral speed
                     1.5   ,    //!< fwd
                     0.2 , //!< default fwd
                     1 , //!< backward
                     0.3 , //!< rolling
                     0.2) //!< yaw
        ->setRange(3)
        ->setAngleBounds(40,0)
        ->setCameraRecul(0,10,-30);


    TransformingMode = new IWalkyrieMode("Transforming");
    TransformingMode->setDefaultAnimator( basicAnimator );
//    SModeDescription& yf19battloid = Modes[NWalkyrieModes::yf19_Battloid];
//    yf19battloid.defineAnimation(18,5);
//
//    yf19battloid.setupSpeeds(0.6 , //!< lateral speed
//                     1.2 ,    //!< fwd
//                     0. , //!< default fwd
//                     1.2 , //!< backward
//                     0.3 , //!< rolling
//                     0.8) //!< yaw
//        .setRange(3)
//        .setAngleBounds(80,0)
//        .setCameraRecul(0,20,-20);

    //!
    FighterMode->setAvailableModes(0,GerwalkMode);
    GerwalkMode->setAvailableModes(FighterMode,0);
}

bool
IWalkyrie::transformInto(IWalkyrieMode* targetedMode)
{
    //
    if( (targetedMode!= nullptr ) &&  (targetedMode != _currentMode) )
    {

//        _targetedMode = targetedMode;

        IWalkyrie::TransformingMode->setAvailableModes( _currentMode, targetedMode);
        _currentMode = IWalkyrie::TransformingMode;
//        getNode()->
        targetFrame( targetedMode->getFrame() );
        return true;
    }

    return false;
}



bool
IWalkyrie::transformIntoNextMode()
{
//    FUS_ASSERT
//    IWalkyrieMode* nextMode =
    return transformInto( _currentMode->getNextMode() );

}

bool
IWalkyrie::transformIntoPreviousMode()
{
    return transformInto( _currentMode->getPreviousMode() );
}





IWalkyrie::IWalkyrie(const char* name) :
//IMultiModeTransformer()
ITransformer(),
_leftBooster(nullptr)
, _rightBooster(nullptr)
, _currentMode(nullptr)
//, _transformingMode(new CTransformingMode())
, _targetedMode(nullptr)
, Name(name)
{

}


IWalkyrie::~IWalkyrie()
{

}

void
IWalkyrie::forceMode(IWalkyrieMode* mode)
{
    FUS_ASSERT(mode != nullptr);
    _currentMode = mode;
}

void
IWalkyrie::OnAnimationEnd(irr::scene::IAnimatedMeshSceneNode*)
{
    //
    _currentMode = IWalkyrie::TransformingMode->getNextMode();
}

void
IWalkyrie::load(irr::scene::IAnimatedMeshSceneNode* node,
//                EWalkyrieMode const& modeId
                IWalkyrieMode* mode
//                , std::initializer_list<IWalkyrieMode*> modes
                )
{
//    #error todo
    ITransformer::load(node);

    _currentMode = mode;
    //Modes[ modeId ]
//    Modes = modes;
}

//int
//IWalkyrie::getFrameFromModeId(const TModeId& id)
//{
//    //!NWalkyrieModes::ERealMode
//    return Modes[ getRealMode(id) ].getFrame();
//
//    //!
//
//}
