#include "IFleet.hpp"
#include "../game_engine.hpp"
#include "../states/IPlayableState.hpp"
#include "../entities/player.hpp"
//#include "CGraphicalLevel.hpp"
//#include "states/CSinglePlayerState.hpp"
#include <fusion/logging/Logger.hpp>
#include <fusion/maths/macros.hpp>
#include <iostream>
#include "../fx/CParticleManager.hpp"
#include "../entities/CBullet.hpp"
#include "../entities/CStaticBattery.hpp"
#include "../entities/CMissile.hpp"
#include "../audio/ISound.hpp"
#include <boost/foreach.hpp>

using namespace irr;




//CSinglePlayerState* state
//IFleet::IFleet(audio::ISoundManager* soundMgr) :
IFleet::IFleet(IPlayableState* state) :
//    _soundMgr(soundMgr)
    _state(state)
    , _elapsedTimeSinceLastCheck(0)
    , _consumingUpdateInterval(1000)    //! par defaut ttes les 1000 sec
//    , _fleetRootNode(0)
{
    //ctor
//    IDummyTransformationSceneNode*
    FUS_ASSERT( _state && "Please set a valid playable state");
//    FUS_ASSERT( _state && "Please set a valid playable state");
}



IFleet::~IFleet()
{


    //dtor
//    if(_fleetRootNode)
//    {
//        _fleetRootNode->remove();
//    }
}


void
IFleet::update(const TTimer::TimeType& elapsedTime)
{
    _elapsedTimeSinceLastCheck += elapsedTime;

    if( _elapsedTimeSinceLastCheck  > _consumingUpdateInterval)
    {
        sporadicCheck();
        _elapsedTimeSinceLastCheck  = 0;
    }

}



//CBullet*
////IStaticBattery*
//IStaticBattery::shootBullet(const char* model,const float& deviation)
//{
//
//
//    CBullet* bullet = getFleet()->createAndSetupBullet(model, this->getRotation().Y + deviation);
//    bullet->setPosition( this->getPosition() );
//    //bullet->
//    return bullet;
//}


/*
// get nearest missile
IStaticBattery*
IFleet::getNearestEnemy(const TVector3df& position)
{


    auto nextBattery(_activeBatteries.begin()), last( _activeBatteries.end() );
    IStaticBattery* current = 0;

    //_INFO << "START \r\n";
    while( nextBattery != last )
    {

        nextBattery++;
//        current = nextBattery;
//        nextBattery = current->_next;

    }
//    while(j != j_end){
//
//        if(j->getPosition().getDistanceFromSQ( position) < nearestMissile->getPosition().getDistanceFromSQ( position)){
//            nearestMissile = j;
//        }
//        ++j;
//    }
//    return &(*nearestMissile);
    return 0;
}



IStaticBattery*
IFleet::getNextTarget(const std::list<IStaticBattery*>& trackedBatteries)
{


    //auto

    //CStaticBattery *nextBattery = _activeBatteries.front();
    //CStaticBattery* current = 0;

    //_INFO << "START \r\n";
    while(nextBattery){

        TTrackedBatteries::const_iterator it = std::find( trackedBatteries.begin(), trackedBatteries.end(), nextBattery );

        // if battery not already tracked
        if(it == trackedBatteries.end() ){

            return nextBattery;
        }


        nextBattery = nextBattery->_next;

    }

    return 0;
}

//void
//IFleet::killEntity(CStaticBattery* ){
//
//}
//










void
IFleet::killAllAlive()
{

    // TODO les mettre tous en deadPool
}



void
IFleet::destroyAll()
{

//static void ();
    clearDeadPool();
    //std::for_each()
}



void
IFleet::clearDeadPool()
{

//    for( : )
    BOOST_FOREACH(auto& pool, _deadPool){

        pool.clear();
    }

    //std::for_each()
}

*/


irr::scene::IAnimatedMesh*
IFleet::getMesh(
                        const char* filename
                        )
{

    FUS_ASSERT( _state );
    return _state->getMesh(filename);
}




CMissile*
IFleet::createAndSetupMissile(const char* model,const TVector3df& forward,const TVector3df& position )
{

    IStaticBattery* battery = getDeadButAllocatedBattery(EEntityType::Missile);
    CMissile* missile = dynamic_cast<CMissile*>(battery);

    missile->setup(
                   model,
                   this,
                   position,
                   forward
                   );

    registerActiveBattery(missile);

    return missile;
}




//,CStaticBattery* creator
//const char* model
CStaticBattery*
IFleet::createAndConfigureStaticBattery()
{

    IStaticBattery* battery = getDeadButAllocatedBattery(EEntityType::Battery);


    //addBattery(batt);
    registerActiveBattery(battery);


    //_INFO << "auto updated battery created with range" << battery->getParameter(NParameters::Range);
    return dynamic_cast<CStaticBattery*>( battery );
}





CBullet*
IFleet::createAndSetupBullet(const char* model,
                  const float& angleDeg
                  //,
                  //const TVector3df& position
                )
{
//, position
    TVector3df forward(0,0,-0.01);
    getVectorFromAngle(angleDeg,forward);
    return createAndSetupBullet(model, forward);
}






//,const TVector3df& position
CBullet*
IFleet::createAndSetupBullet(const char* model,const TVector3df& forwardVec )
{

    IStaticBattery* battery = getDeadButAllocatedBattery(EEntityType::Bullet);

    FUS_ASSERT(battery != nullptr);

    CBullet* bullet = dynamic_cast<CBullet*>(battery);


// setup
//TODO remplacer par un init la ?
    bullet->setFleet(this);
    bullet->setMesh( this->getMesh(model) );

    bullet->_forward = forwardVec;



//    if(!bullet->setup(model,this,position,forward)){
//        _LOG_WARNING << "Could not configure bullet";
//
//        // TODO on devrait le remettre dans le pool
//        delete bullet;
//
//        return 0;
//    }

    // TODO HACK
    //bullet->_parameters

    registerActiveBattery(bullet);

    return bullet;
}



//
//
//
//IStaticBattery*
//IFleet::getDeadButAllocatedBattery(const EEntityType::EId& type)
//{
//
//    IStaticBattery* battery = 0;
//  //  #error not existing
//    if( !_deadPool[type].empty() )
//    {
//
//        battery = _deadPool[type].front();
//        _deadPool[type].pop_front();
//    }
//    else
//    {
//
//        FUS_ASSERT( _state != 0 && "IFleet should have a playable state to refer to");
//        // HACK while game is singleton
//        scene::IAnimatedMeshSceneNode*    node = _state->addAnimatedNode();
//
////        node = smgr->addAnimatedMeshSceneNode( 0,  // fleet
////                                            0,   // parent
////                                            -1, //id
////                                            core::vector3df(0, 0, 0),   //position
////                                            core::vector3df(0, 0, 0), //rotation
////                                            core::vector3df(1.0f, 1.0f, 1.0f), // scale
////                                            true        // add node even without mesh
////                                            );
//
//
////        _INFO << "creating from scratch";
//        switch(type)
//        {
//
//            case EEntityType::Bullet:
//                battery = new CBullet();
//                break;
//
//            case EEntityType::Battery:
//                battery = new CStaticBattery();
//                break;
//
//            case EEntityType::Missile:
//                battery = new CMissile();
//                break;
//
//            default:
//                break;
//        }
//
//
//        //
//        battery->_node = node;
//
//    }
//
//    FUS_ASSERT( battery != 0);
//
//
//
//    return battery;
//}










#if 0


// TODO  passer un shared_ptr ? ne rien renvoyer
bool
IFleet::checkCollisions(IFleet* fleet)
{

    FUS_ASSERT(fleet != 0);



    auto ally = _activeBatteries.begin();
    auto lastAlly  = _activeBatteries.end();

    // foreach unit from this fleet
    for( ;ally != lastAlly ; ++ally)
    {

        auto enemy = fleet->_activeBatteries.begin();
        auto lastEnemy = fleet->_activeBatteries.end();

        // foreach unit from adverse fleet
        for(;enemy != lastEnemy; ++ enemy)
        {

            // if both collide
            if( (*enemy)->checkCollision(*ally) )
//            if( checkCollision( *ally, *enemy) )
            {

                // TODO renommer en ...With
                //_INFO << "collision >> enemy damage before collision [" << enemy->getDamage() << "]";
                onCollision(*ally, *enemy);

//                (*enemy)->onCollision( *ally );
//                (*ally)->onCollision( *enemy );

                //_INFO << "enemy damage after collision [" << enemy->getDamage() << "]";
                return true;
            }

            //enemy = enemy->_next;
        }
        //ally = ally->_next;
    }

    return false;
}

#endif
