/**
* \file single.cpp
*/
#include "CIngamePauseState.hpp"
#include <cmath>
#include <irrlicht.h>
#include "../entities/player.hpp"
#include "../config.hpp"
#include "../game_engine.hpp"
#include "CMenuState.hpp"
#include "COptionsState.hpp"
#include "CScoreState.hpp"
#include "CErrorState.hpp"

using namespace irr;
using namespace video;
using namespace core;
using namespace scene;
using namespace gui;

DECLARE_GAME_SINGLETON( CIngamePauseState )

//! Constructor
CIngamePauseState::CIngamePauseState() :
IGameState("Pause",true,true,true,false,true)
//,_pauseMenu(0)
{

};


bool
CIngamePauseState::load(CGameEngine* engine,irr::scene::ISceneManager* smgr,irr::video::ITexture* screenshot)
{

    if (IGameState::load( engine,smgr,screenshot ) == false)  return false;
//
    GUI_CreatePauseMenu();
//
//    _pauseMenu->setVisible(false);

//    engine().showCursor(true);

    return true;
}



void
CIngamePauseState::unload()
{
    IGameState::unload();
}


//! Destructor
CIngamePauseState::~CIngamePauseState()
{
    //_world->remove();
//    delete _script;
}




/// Function Update()
void
CIngamePauseState::onUpdate(const TTimeUnit& elapsedTime)
{


//    _LOG_DEBUG << "starting updating CIngamePauseState with mode [" << getInnerState() << "]";

    //(this->*_updateFunctions[ getInnerState() ])();
//callm

}


void
CIngamePauseState::onResume()
{

    //_player->setupForNewGame();
}

//void  CIngamePauseState::onHold() ;




//! Render a frame
// en gros l'ecran a une taille de 60
void
CIngamePauseState::Draw()
{


    MainTab->draw();


}




//_player->getScore()






void
CIngamePauseState::onHold()
{


}


/// Create main menu ( = 1st to be displayed )
// Faire un menu de taille dynamique
// Ptet ajouter un bouton restart ?
void
CIngamePauseState::GUI_CreatePauseMenu()
{

    //irr::core::recti tmp(0,0,600,400);
    irr::core::recti tmp(0,0,0,0);
    core::recti rectButton = conf::_MENU_BUTTON_RECT;//(0,0,_BUTTON_WIDTH,_BUTTON_HEIGHT);
//,gui()->getRootGUIElement()
    IGUITab* _pauseMenu 	= gui()->addTab(tmp);
    _pauseMenu->setRelativePositionProportional(core::rectf(0.4f,0.4f,1.f,1.f));



	// faudriat les mettre dans un mm container
	gui()->addButton(rectButton, _pauseMenu, NGuiId::BackToGame,
			L"Back to game", L"Back to game");
//    _MENU_DECAL_RECT(rectButton);
    rectButton += conf::_BUTTON_GAP;

    gui()->addButton(rectButton, _pauseMenu, NGuiId::Options,
			L"Options", L"Go to options");
    rectButton += conf::_BUTTON_GAP;

	gui()->addButton(rectButton, _pauseMenu, NGuiId::AbortGame,
			L"Abort game", L"Go back to main menu");
    rectButton += conf::_BUTTON_GAP;

 	gui()->addButton(rectButton, _pauseMenu, NGuiId::QuitGame,
			L"Quit game", L"Exits game");

    MainTab = _pauseMenu;
}




/// \function HandleEvents
bool
CIngamePauseState::OnEvent(const irr::SEvent& event)
{



    //! According to event type
    switch(event.EventType)
    {
        case EET_KEY_INPUT_EVENT:
            if(!event.KeyInput.PressedDown)
            {
                break;
            }

            // && PressedDown
            if(event.KeyInput.Key == irr::KEY_ESCAPE )
            {
                engine().popState();
            }
            break;

        // HAndle GUI events
        case EET_GUI_EVENT:
            if(event.GUIEvent.EventType == gui::EGET_BUTTON_CLICKED)
            {
                {
                    _INFO << "button clicked";
                    irr::s32 id = event.GUIEvent.Caller->getID();

                    switch(id)
                    {
                        case NGuiId::BackToGame:
                            engine().popState();
                            //engine().SwitchBit(NBit::Pause,false);
                            //_pauseMenu->setVisible(false);
                            break;

                        case NGuiId::Options:
                            engine().pushOptionsState();
                            break;

                        case NGuiId::SaveScore:
                            {
//
//                                this->popThisState();
//                                this->pushState();
/*
                                // donne la possibilit au joueur
                                // d'enregistrer son score
                                this->remove();
                                IBasicGameStatePtr menuState(new CMenuState());
                                engine().PushState( menuState );
                                //true,

                                CScoreState* scoreState = new CScoreState(core::rectf(0.2f,0.2f,0.8f,0.8f)) ;
                                IBasicGameStatePtr scoreStatePtr(scoreState);
                                engine().PushState( scoreStatePtr );
                                //if( state->getMinScore() < _player->getScore())
                                scoreState->displayAddScore( _player->getScore() );
                                */
                            }
                            break;

//                        case NGuiId::ContinueGame:

                            break;

                        case NGuiId::AbortGame:
                            _INFO << "Exiting game from singleplayer state";
                            engine().resetStackAndPushState( new CMenuState() );

                        case NGuiId::QuitGame:
                            _INFO << "Exiting game from singleplayer state";
                            engine().Quit();

                        default:
                            break;
                    };
                }
            }
            break;

        default:
            break;
    } // end 1nd switch

    return false;
}



